#include "stdafx.h"
#include "chronicle.h"
#include "chronicleDlg.h"

struct hotfix
{
	struct hotfix *next;
	char *article;
	char *desc;
	char *url;
	int risk;
};

struct regcheck
{
	struct regcheck *next;
	char *location;
	char *desc;
};

struct hotfix *ntsp3hotfix;
struct regcheck *ntsp3regcheck;
struct hotfix *ntsp4hotfix;
struct regcheck *ntsp4regcheck;

void init(void)
{
	ntsp3hotfix=NULL;
	ntsp3regcheck=NULL;
	ntsp4hotfix=NULL;
	ntsp4regcheck=NULL;
}

int addhotfix(struct hotfix **head, char *article, char *desc, 
			  char *url,int risk)
{
	struct hotfix *newguy,*walker;

	newguy=malloc(sizeof(struct hotfix));
	newguy->next=NULL;
	newguy->article=article;
	newguy->desc=desc;
	newguy->url=url;
	newguy->risk=risk;

	if (!*head)
		*head=newguy;

	walker =*head;
	while (walker->next!=NULL)
		walker=walker->next;

	walker->next=newguy;
}

int addregcheck(struct regcheck **head, char *location, char *desc)
{
	struct regcheck *newguy,*walker;

	newguy=malloc(sizeof(struct regcheck));
	newguy->next=NULL;
	newguy->location=location;
	newguy->desc=desc;

	if (!*head)
		*head=newguy;

	walker =*head;
	while (walker->next!=NULL)
		walker=walker->next;

	walker->next=newguy;
}

int parse(void)
{
	FILE *f;
	char line[1024],*temp;
	char article[1024],desc[1024],url[1024];
	int sp=0,risk=1;

	f=fopen("chronicle.dat","r");
	if (!f)
		return 0;

	while (fgets(line,sizeof(line),f)!=NULL)
	{
		/* comments */
		risk=1;

		if (line[0]=='#') continue;
		if (!strncmp(line,"SP4",3))
		{
			sp=1;
			continue;
		}
		if (!strncmp(line,"REGCHECK",8))
		{
			// Not dead yet
		}
		else if (!strncmp(line,"HOTFIX",6))
		{
			temp=strrchr(line,':');
			if (!temp)
				continue;
			*temp++=0;
			strncpy(article,temp,(sizeof(article)-1));
			if (article[strlen(article)-1]=='!')
			{
				article[strlen(article)-1]=0;
				risk=0;
			}
			if (fgets(line,sizeof(line),f)!=NULL)
				return 0;
			strncpy(desc,line,(sizeof(line)-1));
			if (fgets(line,sizeof(line),f)!=NULL)
				return 0;
			strncpy(url,line,(sizeof(line)-1));
			if (!sp)
				addhotfix(&ntsp3hotfix,article,desc,url,risk);
			else
				addhotfix(&ntsp4hotfix,article,desc,url,risk);
		}
		else
		{
			return 0;
		}
	}

	fclose(f);
	return 1;
}